"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var RenameLocationTextManipulator = /** @class */ (function () {
    function RenameLocationTextManipulator(renameLocations, newName) {
        this.renameLocations = renameLocations;
        this.newName = newName;
    }
    RenameLocationTextManipulator.prototype.getNewText = function (inputText) {
        var e_1, _a;
        // get the rename locations in reverse order
        var renameLocations = this.renameLocations.map(function (l) { return l.getTextSpan(); }).sort(function (a, b) { return b.getStart() - a.getStart(); });
        var newFileText = inputText;
        try {
            for (var renameLocations_1 = tslib_1.__values(renameLocations), renameLocations_1_1 = renameLocations_1.next(); !renameLocations_1_1.done; renameLocations_1_1 = renameLocations_1.next()) {
                var textSpan = renameLocations_1_1.value;
                var start = textSpan.getStart();
                var end = start + textSpan.getLength();
                newFileText = newFileText.substring(0, start) + this.newName + newFileText.substring(end);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (renameLocations_1_1 && !renameLocations_1_1.done && (_a = renameLocations_1.return)) _a.call(renameLocations_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return newFileText;
    };
    RenameLocationTextManipulator.prototype.getTextForError = function (newText) {
        if (this.renameLocations.length === 0)
            return newText;
        return "..." + newText.substring(this.renameLocations[0].getTextSpan().getStart());
    };
    return RenameLocationTextManipulator;
}());
exports.RenameLocationTextManipulator = RenameLocationTextManipulator;
